    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <fstream>
#include <sstream>
#include <new>
using namespace std;
#include "o3outstream.h"
#include "o3eps.h"
#include "o3settings.h"
#include "o3opiheader.h"
#include "o3image.h"
#include "o3exceptions.h"

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..public......................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

EPSImage::EPSImage(const string& filename, IncludedImage& clonesrc)
{
	//char tmp[300];
	ostringstream tmp;

	opiheader = clonesrc.header()->clone();

	eps.open(filename.c_str(), ifstream::in | ifstream::binary);
	if (eps.fail()) {
		error = true;
		return;
	} else
		error = false;

	eps.seekg(0, ifstream::end);
	epsdatasize = eps.tellg();
	eps.seekg(0, ifstream::beg);

	epsfilename = filename;
	
	tmp << Literals::PostScript::IncludedImageQuality << " 3";
	opiheader->headerItem(OPIHeader::HI_includedimagequality)->set(tmp.str());
}

EPSImage::~EPSImage()
{
	if (!error)
		eps.close();

	delete opiheader;
}

BinLOb* EPSImage::read()
{
	BinLOb *data;
	try {
		data = new BinLOb(1024*1024);
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	eps.read(data->rwData(), data->bufSize());
	data->size(eps.gcount());

	return data;
}

void EPSImage::writeImage(OPIVersion version)
{
	bool useopi13 = false;
	bool useopi20 = false;

	if (version == Image::eOPI13)
		useopi13 = true;
	else if (version == Image::eOPI20)
		useopi20 = true;
	else if (version == Image::eOPIMixed)
		useopi13 = useopi20 = true;

	if (useopi13)
		writeOPI13Comments1();

	if (useopi20)
		writeOPI20Comments1();

	writeGraphicsState(Image::eEPS);

	if (useopi20)
		writeOPI20Comments2();

	writeImageData();

	if (useopi20)
		writeOPI20Comments3();

	if (useopi13)
		writeOPI13Comments2();
	
	delete this;		// suicide..
}

inline bool EPSImage::eoimage() const
{
	if (eps.eof())
		return true;
	else
		return false;
}

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..private.....................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

void EPSImage::writeImageData()
{
//	char tmp[300];
	ostringstream tmp;
	int i;

	for (i = 0;; i++) {
		if (!Literals::PostScript::EPSCodeLines1[i].length())
			break;
		writeText(Literals::PostScript::EPSCodeLines1[i].c_str());
	}

	tmp << Literals::PostScript::BeginData << " " << epsdatasize+17+13+epsfilename.length()+2*settings->getLineSepLen() << " Hex Bytes";
	writeText(tmp.str());
	
	tmp.str(Literals::NullString);
	tmp << Literals::PostScript::BeginDocument << " " << epsfilename;
	writeText(tmp.str());

	while (!eoimage())
		outputstream->write(read());

	writeText(Literals::PostScript::EndDocument);
	writeText(Literals::NullString);
	writeText(Literals::PostScript::EndData);

	for (i = 0;; i++) {
		if (!Literals::PostScript::EPSCodeLines2[i].length())
			break;
		writeText(Literals::PostScript::EPSCodeLines2[i]);
	}

}
