    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include "o3server.h"
#include "o3settings.h"
#include "o3headeritem.h"

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..public......................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

HeaderItem::HeaderItem()
{
	clear();
}

HeaderItem::HeaderItem(int null)
{
	clear();
}

HeaderItem::HeaderItem(const string& str)
{
	valid = true;
	value = str;
	linedata = str;
}

string HeaderItem::getValue() const
{
	return value;
}

string HeaderItem::getLineData() const
{
	return linedata;
}

string HeaderItem::getLineDataX() const
{
	int a,c,x,brcount;

	brcount = 0;
	a = 0;
	c = 0;

	for (x = 0; x < linedata.length(); x++) {
		switch (linedata.at(x)) {
			case '(':	brcount++;
						break;

			case ')':	brcount--;
						break;

			case ' ':	if (brcount)
							break;

						while (linedata.at(++x) == ' ')
							if (x >= linedata.length())
								break;

						return linedata.substr(x, linedata.length());
		}
	}

	string tmp;
	tmp.assign("");
	return tmp;
}

void HeaderItem::add(const CommentLOb& comment)
{
	valid = true;
	value += comment.getRestOfLine(1);  // only "foo bar"
	
	if (linedata.length() == 0)
		linedata += comment;  // "%%comment foo bar"
	else {
		linedata.append(settings->getLineSep());
		linedata += comment;
	}
	// note: the outstream writes after every comment a cr/&lf..
}

void HeaderItem::add(const TextLOb& text)
{
	valid = true;
	value += text;
	
	if (linedata.length() == 0)
		linedata += text;  // "%%comment foo bar"
	else { 
		linedata.append(settings->getLineSep());
		linedata += text;
	}
	// note: the outstream writes after every comment a cr/&lf..
}

void HeaderItem::add(const char *str)
{
	valid = true;
	value.append(str);

	if (linedata.length() == 0)
		linedata.append(str);
	else { 
		linedata.append(settings->getLineSep());
		linedata.append(str);
	}
	// note: the outstream writes after every comment a cr/&lf..
}

void HeaderItem::clear()
{
	valid = false;
	value = "";
	linedata = "";
}

void HeaderItem::set(const CommentLOb& comment)
{
	valid = true;
	value = comment.getRestOfLine(1);
	linedata = comment;
}

void HeaderItem::set(const TextLOb& text)
{
	valid = true;
	value = text;
	linedata = text;
}

void HeaderItem::set(const char* str)
{
	valid = true;
	value.assign(str);
	linedata.assign(str);
}

void HeaderItem::set(const string& str)
{
	valid = true;
	value.assign(str);
	linedata.assign(str);
}

void HeaderItem::clone(HeaderItem& source)
{
	if (source.isValid()) {
		value = source.getValue();
		linedata = source.getLineData();
		valid = true;
	} else valid = false;
}

int HeaderItem::getInt(int index) const
{
	return atoi(getpstoken(value, index).c_str());
}

float HeaderItem::getFloat(int index) const
{
	return atof(getpstoken(value, index).c_str());
}

string HeaderItem::getString(int index) const
{
	return getpstoken(value, index);
}


bool HeaderItem::isValid() const
{
	return valid;
}

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..private.....................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

string HeaderItem::getpstoken(const string& str, int index) const
{ 
	int a,b,c,x,brcount;

	brcount = 0;
	a = 0;
	c = 0;

	for (x = 0; x < str.length(); x++) {
		switch (str.at(x)) {
			case '(':	brcount++;
						break;

			case ')':	brcount--;
						break;

			case ' ':	if (brcount)
							break;

						b = x;

						if (c == index)
							return str.substr(a, b-a);

						c++;

						while (str.at(x+1) == ' ')
							x++;

						a = x+1;
						break;
		}
	}
	b = str.length();
	return str.substr(a, b-a);
}
