    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <iostream>
#include <sstream>
#include <new>
using namespace std;
#include "o3image.h"
#include "o3eps.h"
#include "o3outstream.h"
#include "o3opiheader.h"
#include "o3exceptions.h"

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..public......................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..protected...................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

OPIHeader *Image::header()
{
	return opiheader;
}

void Image::writeGraphicsState(GFXType type)
{
	ostringstream tmp;
	float llx,lly,ulx,uly,urx,ury,lrx,lry;
	float a,b,c,d,tx,ty,w,h;


	if (!writeIfValid(*(opiheader->headerItem(OPIHeader::HI_graphicsstate))))	{

		if (opiheader->headerItem(OPIHeader::HI_aldimageoverprint)->isValid()) {
			
			TextLOb *text;
			try {
				 text = new TextLOb;
			}
			catch(bad_alloc) {
				throw ExceptionOutOfMemory(__FILE__, __LINE__);
			}

			text->assign(opiheader->headerItem(OPIHeader::HI_aldimageoverprint)->getValue());
			text->append(" setoverprint");
			outputstream->write(text);
		}

		w = opiheader->headerItem(OPIHeader::HI_aldimagedimensions)->getFloat(0);
		h = opiheader->headerItem(OPIHeader::HI_aldimagedimensions)->getFloat(1);

		llx = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(0);
		lly = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(1);
		ulx = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(2);
		uly = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(3);
		urx = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(4);
		ury = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(5);
		lrx = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(6);
		lry = opiheader->headerItem(OPIHeader::HI_aldimageposition)->getFloat(7);

		a = (lrx - llx) / w;
		b = (lry - lly) / w;
		c = (ulx - llx) / h;
		d = (uly - lly) / h;
		tx = llx;
		ty = lly;

		TextLOb *text;
		try {
			text = new TextLOb;
		}
		catch(bad_alloc) {
			throw ExceptionOutOfMemory(__FILE__, __LINE__);
		}

//		sprintf(tmp, "[%f %f %f %f %f %f] concat", a, b, c, d, tx, ty); // default precision is 6
		tmp << "[" << a << " " << b << " " << c << " " << d << " " << tx << " " << ty << "] concat";
		text->assign(tmp.str());
		outputstream->write(text);

		if (type != eEPS) {

			try {
				text = new TextLOb;
			}
			catch(bad_alloc) {
				throw ExceptionOutOfMemory(__FILE__, __LINE__);
			}

			tmp.str(Literals::NullString);
//			sprintf(tmp, "[%u 0 0 %u 0 0] concat", ,
//				);
			tmp << "[" << opiheader->headerItem(OPIHeader::HI_aldimagedimensions)->getInt(0)
				<< " 0 0 " << opiheader->headerItem(OPIHeader::HI_aldimagedimensions)->getInt(1)
				<< " 0 0] concat";
			text->assign(tmp.str());
			outputstream->write(text);
		}
	}
}

void Image::write(const HeaderItem& item)
{
	TextLOb *text;
	try {
		text = new TextLOb;
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	text->assign(item.getLineData());
	outputstream->write(text);
}

void Image::writeX(const char* str, const HeaderItem& item)
{
	TextLOb *text;
	try {
		text = new TextLOb;
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	text->assign(str);
	text->append(item.getLineDataX());
	outputstream->write(text);
}

void Image::writeX(const string& str, const HeaderItem& item)
{
	TextLOb *text;
	try {
		text = new TextLOb;
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	text->assign(str);
	text->append(item.getLineDataX());
	outputstream->write(text);
}

bool Image::writeIfValid(const HeaderItem& item)
{
	if (item.isValid()) {
		TextLOb *text;
		try {
			text = new TextLOb;
		}
		catch(bad_alloc) {
			throw ExceptionOutOfMemory(__FILE__, __LINE__);
		}

		text->assign(item.getLineData());
		outputstream->write(text);
		return true;
	}
	return false;
}

bool Image::writeIfValidX(const char* str, const HeaderItem& item)
{
	if (item.isValid()) {
		TextLOb *text;
		try {
			text = new TextLOb;
		}
		catch(bad_alloc) {
			throw ExceptionOutOfMemory(__FILE__, __LINE__);
		}

		text->assign(str);
		text->append(item.getLineDataX());
		outputstream->write(text);
		return true;
	}
	return false;
}

bool Image::writeIfValidX(const string& str, const HeaderItem& item)
{
	if (item.isValid()) {
		TextLOb *text;
		try {
			text = new TextLOb;
		}
		catch(bad_alloc) {
			throw ExceptionOutOfMemory(__FILE__, __LINE__);
		}

		text->assign(str);
		text->append(item.getLineDataX());
		outputstream->write(text);
		return true;
	}
	return false;
}

void Image::writeText(const char* str)
{
	TextLOb *text;
	try {
		text = new TextLOb;
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	text->assign(str);
	outputstream->write(text);
}

void Image::writeText(const string& str)
{
	TextLOb *text;
	try {
		text = new TextLOb;
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	text->assign(str);
	outputstream->write(text);
}

void Image::writeOPI20Comments1()
{
	map<int, HeaderItem>::iterator i;
	CommentLOb tmpcmt;
	string tmpstr;
//	char tmp[300];
	ostringstream tmp;

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_beginopi))) {
		tmpstr = Literals::PostScript::BeginOPI + " 2.0";
		writeText(tmpstr);
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_distilled));

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_imagefilename))) {
		tmpstr = Literals::PostScript::ImageFileName + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimagefilename));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_mainimage))) {
		tmpstr = Literals::PostScript::MainImage + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimageid));
	}

	if(opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->begin() != opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->end())
		for (i = opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->begin(); i != opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->end(); i++)
			write(i->second);
	else
		for (i = opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->begin(); i != opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->end(); i++) {
//			sprintf(tmp, Literals::PostScript::TIFFASCIITagInt.c_str(), i->first);
			tmp << Literals::PostScript::TIFFASCIITag << " " << i->first;
			tmpcmt.assign(i->second.getLineData());
//			tmpstr = ;
//			tmpstr += );
			writeText(tmp.str()+tmpcmt.getRestOfLine(2));
		}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_imagedimensions))) {
		tmpstr = Literals::PostScript::ImageDimensions + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimagedimensions));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_imagecroprect))) {
		tmpstr = Literals::PostScript::ImageCropRect + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimagecroprect));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_imageoverprint))) {
		tmpstr = Literals::PostScript::ImageOverprint + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimageoverprint));
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_imageinks));
}

void Image::writeOPI20Comments2()
{
	string tmpstr;

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_beginincludedimage)))
		writeText(Literals::PostScript::BeginIncludedImage);

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_includedimagedimensions))) {
		tmpstr = Literals::PostScript::IncludedImageDimensions + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimagedimensions));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_includedimagetype))) {
		tmpstr = Literals::PostScript::IncludedImageType + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_aldimagetype));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_includedimagequality))) {
		tmpstr = Literals::PostScript::IncludedImageQuality + " 3";
		writeText(tmpstr);
	}
}

void Image::writeOPI20Comments3()
{
	writeText(Literals::PostScript::EndIncludedImage);

	if (printerrfilename.length()) {
		int a = 0;
		while ((a = printerrfilename.find('\\', a)) != string::npos) {
			printerrfilename.insert(++a, "\\");
			++a;
		}

		a = 0;
		while ((a = printerrfilename.find('(', a)) != string::npos) {
			printerrfilename.insert(a, "\\");
			a += 2;
		}

		a = 0;
		while ((a = printerrfilename.find(')', a)) != string::npos) {
			printerrfilename.insert(a, "\\");
			a += 2;
		}

		writeText("/Times-Roman findfont 0.042 scalefont setfont");
		writeText("0 0.23 moveto");
		writeText("{");
		writeText("  pop pop");
		writeText("  currentpoint pop 0.42 gt");
		writeText("  {");
		writeText("     currentpoint 0.042 sub");
		writeText("     exch pop 0");
		writeText("     exch moveto");
		writeText("  } if");
		string tmp("} (");
		tmp += printerrfilename;
		tmp += ") kshow";
		writeText(tmp);

		printerrfilename = "";
	}

	writeText(Literals::PostScript::EndOPI);
}

void Image::writeOPI13Comments1()
{
	map<int, HeaderItem>::iterator i;
	CommentLOb tmpcmt;
	string tmpstr;
//	char tmp[300];
	ostringstream tmp;

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagefilename))) {
		tmpstr = Literals::PostScript::ALDImageFileName + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_imagefilename));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimageid))) {
		tmpstr = Literals::PostScript::ALDImageID + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_mainimage));
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldobjectcomments));

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagedimensions))) {
		tmpstr = Literals::PostScript::ALDImageDimensions + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_imagedimensions));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagecroprect))) {
		tmpstr = Literals::PostScript::ALDImageCropRect + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_imagecroprect));
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagecropfixed));

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimageposition))) {
		TextLOb *text;
		try {
			text = new TextLOb;
		}
		catch(bad_alloc) {
			throw ExceptionOutOfMemory(__FILE__, __LINE__);
		}

		text->assign(Literals::PostScript::ALDImagePosition);
		text->append(" 0 0 ");
		text->append(opiheader->headerItem(OPIHeader::HI_imagedimensions)->getValue());
		outputstream->write(text);
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimageresolution));
	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagecolortype));
	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagecolor));
	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagetint));

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimageoverprint))) {
		tmpstr = Literals::PostScript::ALDImageOverprint + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_imageoverprint));
	}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagetype))) {
		tmpstr = Literals::PostScript::ALDImageType + " ";
		writeIfValidX(tmpstr, *opiheader->headerItem(OPIHeader::HI_includedimagetype));
	}

	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagegraymap));
	writeIfValid(*opiheader->headerItem(OPIHeader::HI_aldimagetransparency));

	if(opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->begin() != opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->end())
		for (i = opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->begin(); i != opiheader->headerItemMap(OPIHeader::HIM_aldimageasciitags)->end(); i++)
			write(i->second);
	else
		for (i = opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->begin(); i != opiheader->headerItemMap(OPIHeader::HIM_tiffasciitags)->end(); i++) {
//			sprintf(tmp, Literals::PostScript::ALDImageASCIITagInt.c_str(), i->first);
			tmpcmt.assign(i->second.getLineData());
			tmp << Literals::PostScript::ALDImageASCIITag << i->first << ":";
//			tmpstr = ;
			writeText(tmp.str()+tmpcmt.getRestOfLine(1));
		}

	if (!writeIfValid(*opiheader->headerItem(OPIHeader::HI_beginobject))) {
		tmpstr = Literals::PostScript::BeginObject + " image";
		writeText(tmpstr);
	}
}

void Image::writeOPI13Comments2()
{
	writeText(Literals::PostScript::EndObject);


	if (printerrfilename.length()) {
		int a = 0;
		while ((a = printerrfilename.find('\\', a)) != string::npos) {
			printerrfilename.insert(++a, "\\");
			++a;
		}

		a = 0;
		while ((a = printerrfilename.find('(', a)) != string::npos) {
			printerrfilename.insert(a, "\\");
			a += 2;
		}

		a = 0;
		while ((a = printerrfilename.find(')', a)) != string::npos) {
			printerrfilename.insert(a, "\\");
			a += 2;
		}

		writeText("/Times-Roman findfont 0.042 scalefont setfont");
		writeText("0 0.23 moveto");
		writeText("{");
		writeText("  pop pop");
		writeText("  currentpoint pop 0.42 gt");
		writeText("  {");
		writeText("     currentpoint 0.042 sub");
		writeText("     exch pop 0");
		writeText("     exch moveto");
		writeText("  } if");
		string tmp("} (");
		tmp += printerrfilename;
		tmp += ") kshow";
		writeText(tmp);

		printerrfilename = "";
	}
}
