    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <string>
using namespace std;

#ifndef __o3image__
#define __o3image__

#include "o3bin.h"
#include "o3opiheader.h"

class Image {
public:
	enum OPIVersion {
		eOPI13,
		eOPI20,
		eOPIMixed
	};
	enum GFXType {
		eIncluded,
		eTIFF,
		eEPS
	};

	virtual BinLOb*		read() = 0;
	virtual bool		eoimage()	const = 0;
	virtual void		writeImage(OPIVersion version) = 0;
	OPIHeader*			header();


	string				printerrfilename;

protected:
	OPIHeader			*opiheader;
						
	void				writeGraphicsState(GFXType type);
	void				write(const HeaderItem& item);
	void				writeX(const char* str, const HeaderItem& item);
	void				writeX(const string& str, const HeaderItem& item);
	bool				writeIfValid(const HeaderItem& item);
	bool				writeIfValidX(const char* str, const HeaderItem& item);
	bool				writeIfValidX(const string& str, const HeaderItem& item);
	void				writeText(const char* str);
	void				writeText(const string &str);
	void				writeOPI13Comments1();
	void				writeOPI13Comments2();
	void				writeOPI20Comments1();
	void				writeOPI20Comments2();
	void				writeOPI20Comments3();
};

#endif // __o3image__
