    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#ifndef __o3included__
#define __o3included__

#include "o3bin.h"
#include "o3image.h"
#include "o3comment.h"
#include "o3headeritem.h"
#include "o3literals.h"

class IncludedImage : public Image {
public:
	enum ImageStatus {
		eLoading,
		eComplete,
		eNotIncluded
	};

						IncludedImage();
						~IncludedImage();
	BinLOb*				read();
	void				writeImage(OPIVersion version);			
	bool				onComment(const CommentLOb *comment);
	bool				onText(const TextLOb *text);
	bool				eoimage()		const;
	bool				OPI13Included() const;
	bool				OPI20Included() const;
	ImageStatus			getStatus()		const;

private:
	int					lasttifftag13;
	int					lasttifftag20;
	HeaderItem			*lastitem;
	ImageStatus			status;
	enum {
		eNone,
		eHeaderItem,
		eTIFFTag13,
		eTIFFTag20
	}					lasttype;				
	enum {
		eReturn,
		eGraphicsState,
		eImageOperands
	}					textredirectmode;
	bool				inopi13block;
	bool				inopi20block;

	bool				CMP(const string& str1, const char *str2);
	bool				CMP(const string& str1, const string& str2);
						
	void				onAddComment(const CommentLOb& comment);
	void				onBeginData(const CommentLOb& comment);
	void				onBeginBinary(const CommentLOb& comment);
	void				noImageIncluded();
						
	// OPI 1.3			
	void				onALDImageFileName(const CommentLOb& comment);
	void				onALDImageID(const CommentLOb& comment);
	void				onALDObjectComments(const CommentLOb& comment);
	void				onALDImageDimensions(const CommentLOb& comment);
	void				onALDImageCropRect(const CommentLOb& comment);
	void				onALDImageCropFixed(const CommentLOb& comment);
	void				onALDImagePosition(const CommentLOb& comment);
	void				onALDImageResolution(const CommentLOb& comment);
	void				onALDImageColorType(const CommentLOb& comment);
	void				onALDImageColor(const CommentLOb& comment);
	void				onALDImageTint(const CommentLOb& comment);
	void				onALDImageOverprint(const CommentLOb& comment);
	void				onALDImageType(const CommentLOb& comment);
	void				onALDImageGrayMap(const CommentLOb& comment);
	void				onALDImageTransparency(const CommentLOb& comment);
	void				onALDImageASCIITag(const CommentLOb& comment);
	void				onBeginObject(const CommentLOb& comment);
						
	// OPI 2.0			
	void				onBeginOPI(const CommentLOb& comment);
	void				onDistilled(const CommentLOb& comment);
	void				onImageFileName(const CommentLOb& comment);
	void				onMainImage(const CommentLOb& comment);
	void				onTIFFASCIITag(const CommentLOb& comment);
	void				onImageDimensions(const CommentLOb& comment);
	void				onImageCropRect(const CommentLOb& comment);
	void				onImageOverprint(const CommentLOb& comment);
	void				onImageInks(const CommentLOb& comment);
	void				onBeginIncludedImage(const CommentLOb& comment);
	void				onIncludedImageDimensions(const CommentLOb& comment);
	void				onIncludedImageType(const CommentLOb& comment);
	void				onIncludedImageQuality(const CommentLOb& comment);
						
	void				writeImageData();
	void				writeImageOperands();
};

#endif // __o3included__
