    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <new>
using namespace std;
#include "o3instream.h"
#include "o3linebuffer.h"
#include "o3exceptions.h"
#include "o3literals.h"

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..public......................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

LineBuffer::LineBuffer(int buffersize) : inputbuffersize(buffersize)
{
	try {
		inputbuffer = new char[buffersize];
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	bufferend = inputbuffer + buffersize;
	bufferpos = bufferend;			// invd buffer

}

LineBuffer::~LineBuffer()
{
	free(inputbuffer);
}

const string& LineBuffer::getLine()
{
	bool crlfdetected = false;
	int copylen;
	linebuffer.assign("");

	fillBuffer();
	if (bufferpos >= bufferend)
		return linebuffer;

	while ((*bufferpos == Literals::CR) || (*bufferpos == Literals::LF)) {
		bufferpos++;
		copystart++;
		fillBuffer();
		if (bufferpos >= bufferend)
			return linebuffer;
	}

	do {
		fillBuffer();
		if (bufferpos >= bufferend)
			return linebuffer;

		while (bufferpos<bufferend) {
			if (*bufferpos == Literals::CR) { 
				crlfdetected = true;
				break;
			} else if (*bufferpos == Literals::LF) {
				crlfdetected = true;
				break;
			}
			bufferpos++;
		}

		copylen = bufferpos - copystart;
		linebuffer.append(copystart, copylen);
		copystart = bufferpos;
	} while (!crlfdetected);
	

	while (((*bufferpos == Literals::CR) || (*bufferpos == Literals::LF)) && (bufferpos < bufferend)) {
		bufferpos++;
		copystart++;
		fillBuffer();
	}

	return linebuffer;
}


bool LineBuffer::isValid() const
{
	if (bufferpos < bufferend)
		return true;
	else 
		return false;
}

BinLOb* LineBuffer::getBin(int bytes)
{
	BinLOb *bin;
	try {
		bin = new BinLOb(bytes);
	}
	catch(bad_alloc) {
		throw ExceptionOutOfMemory(__FILE__, __LINE__);
	}

	if (bufferpos < bufferend) {
		if (bytes > bufferend - bufferpos)
			bytes = bufferend - bufferpos;
		bin->saveData(bufferpos, bytes);
		bufferpos += bin->size();
	}

	return bin;
}

  //////////////////////////////////////////////////////////////////////////////////////////////////
 //..private.....................................................................................//
//////////////////////////////////////////////////////////////////////////////////////////////////

inline void LineBuffer::fillBuffer()
{
	if ((bufferpos >= bufferend) && !inputstream->streameof())	{
		inputstream->readRaw(inputbuffer, inputbuffersize);
		bufferend = inputbuffer + inputstream->gcount();
		bufferpos = inputbuffer;
		copystart = inputbuffer;
	}
}

