    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/
#include <string>
#include <fstream>
#include <iostream>
#include <typeinfo>
using namespace std;
#include "o3outstream.h"
#include "o3bin.h"
#include "o3text.h"
#include "o3comment.h"
#include "o3settings.h"
#include "o3exceptions.h"

OutputStream *outputstream;

OutputStream::~OutputStream()
{
	if (!usecout)
		ofstream::close();
}

void OutputStream::open(const string& filename)
{
	OutputStream::filename = filename;
	ofstream::open(filename.c_str(), ios::out | ios::binary);

	if (fail())
		throw ExceptionFOpenFailed(filename, __FILE__, __LINE__);

	usecout = false;
}

void OutputStream::usecoutstream()
{
	usecout = true;
}

void OutputStream::write(LOb *lob)	// LOb writer & killer
{
	if (typeid(*lob) == typeid(TextLOb)) {
		static_cast<TextLOb*>(lob)->append(settings->getLineSep());
	} else if (typeid(*lob) == typeid(CommentLOb)) {
		static_cast<CommentLOb*>(lob)->append(settings->getLineSep());
	}

	if (usecout)
		cout.write(lob->rData(), lob->size());
	else
		ofstream::write(lob->rData(), lob->size());

	delete lob;
}

void OutputStream::nulldevice(LOb *lob)	// LOb-killer :[]
{
	delete lob;
}

const string& OutputStream::dst() const
{
	return filename;
}
