/*///
//     .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
//    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
//                             //////////////////////////////////////////*/
                           

// define this, if you want to compile opi3 for the use with the
// ebios x-pie software. the last ending will be cut away.
#define XPIE

#include "o3path3.h"
#include "o3settings.h"
#include "o3log.h"

/* beim pfad wird immer ein delim angehaengt, falls keiner da ist

     >> /unix/sux/extre.me
match > /unix/
  del..       sux/extre.me
dest  > c:\foo\bar\ 
     >> c:\foo\bar\sux\extre.me

 /unix/sux/extre.me
 c:\windoze\bah.dat
 MacOSuX:the:biggest:crap:in.the.world
*/


Path3::Path3(const char *newpath, bool referencesfile) : path(newpath)
{
	detectType();
	reffile = referencesfile;
	appendPathDelim();
}

Path3::Path3(const string &newpath, bool referencesfile) : path(newpath)
{
	detectType();
	reffile = referencesfile;
	appendPathDelim();
}

void Path3::setPath(const string &newpath, bool referencesfile)
{
	path.assign(newpath);
	detectType();
	reffile = referencesfile;
	appendPathDelim();
}

void Path3::appendPathDelim()
{
	if (!reffile) {
		int a = path.length();
		if (a > 0) {
			--a;

			switch (type) {
				case eUnix:		if (path.at(a) != '/')
									path.append("/");
								break;
				case eWinDos:	if (path.at(a) != '\\')
									path.append("\\");
								break;
				case eMacOS:	if (path.at(a) != ':')
									path.append(":");
			}
		}
	}
}

void Path3::detectType()
{
	int a;
	if ((a = path.find('*')) != string::npos) {
		path.erase(a, 1);
		usefileonly = true;
	} else
		usefileonly = false;

	if (path.find('/') != string::npos)
		type = eUnix;
	else if (path.find('\\') != string::npos)
		type = eWinDos;
	else if (path.find(':') != string::npos)
		type = eMacOS;
	else {
		type = eEmpty;
		usefileonly = true;
		path.erase();
	}
}

bool Path3::beginningMatches(const Path3 &match)
{
	const string &fp = match.getFullPath();
	int a, b = fp.length(), c = path.length();

	const char *p = path.c_str();
	const char *m = fp.c_str();

	switch (type) {
		case eUnix:		for (a = 0; a < b; ++a)		// case sensitive cmp, gilt auch fuer ""
							if (a > c || p[a] != m[a])
								return false;
						return true;
		case eWinDos:
		case eMacOS:	for (a = 0; a < b; ++a)	{	// case insensitive cmp
							if (a > c)
								return false;

							if ((p[a] >= 'A' && p[a] <= 'Z') || (p[a] >= 'a' && p[a] <= 'z') &&
								(m[a] >= 'A' && m[a] <= 'Z') || (m[a] >= 'a' && m[a] <= 'z')) {

								if ((p[a] - m[a]) & 0x1f)
									return false;
							} else if (p[a] != m[a])
								return false;
						}
						return true;
	}

	return false;
}

bool Path3::convertPath(const Path3 &match, const Path3 &dest)
{
//        opilog->write("match: " + match.getFullPath() + "\n");
//        opilog->write("dest : " + dest.getFullPath() + "\n");
        
	if (beginningMatches(match)) {
		if (!match.usefileonly) {
			path.erase(0, match.getPath().length());		// die pfade noch mit dazu nehmen

			switch (dest.getType()) {
				case eUnix:	convertRelToUnix(); break;
				case eWinDos:	convertRelToWinDos(); break;
				case eMacOS:	convertRelToMacOS(); break;
			}
		} else
		path = getFileName();							// nur die destpath+datei

		type = dest.getType();

		path.insert(0, dest.getPath());
                
                // FIXME sb-hack
                // MacOS appleshare brackets will be deleted
                if ( path.at(path.length() - 1) == ')' ) path.erase(path.length() - 1);
                
#ifdef XPIE
                // FIXME sb-hack
                // erase the last ending, since we ALWAYS add one with opisync!
                // this will NOT work if you use opi3 with other than the 
                // x-pie software from ebios (hence the define)
                int a = path.rfind('.');
                if (a != string::npos) path.erase(a, path.length() - 1);
#endif                
                
                // check if we got a smb-path and have to go searching...
                if ( match.getFullPath().at(0) == '\\' && match.getFullPath().at(1) == '\\') {
//                        opilog->write("----------\nOh man... SMB-path! trying to find file...\n");
                        
//                        opilog->write("File: " + getFileName() + "\n");
//                        opilog->write("Path: " + getPath() + "\n");
                        findFile(getFileName());
//                        opilog->write("----------\n");
                }
                
//                oplilog->write("-- : " + path.c_str() + "\n");
                
		return true;
	} else
		return false;		// wurde nicht konvertiert
}

// find a file even if it's in hicaps
// calling external script...
void Path3::findFile(string name)
{
         char buf[1024];
         FILE *ptr;
         FILE *script;
         string file = "";
         string finalpath = "";
         
         // create command-line command
         string command = settings->findscript;
         command += " " + name;
        
         script = fopen(settings->findscript.c_str(), "r");
         
         // can we find the script?
         if (script != NULL)
         {
                 fclose(script);
                 
//                 opilog->write("Command: " + command + "\n");
//                 opilog->write("searching results...\n");
                 
                 // execute the find-script
                 if ((ptr = popen(command.c_str(), "r")) != NULL)
                 {
                         
                         // we only want the first line of output from the script
                         while (fgets(buf, 1024, ptr) != NULL)
                         {
//                                 opilog->write("  ----------\n");
                                 // Attention, there is a Linebreak at the End!!
                                 file = buf;
                                 // eliminate newline in filename if there is one
                                 if ( file.at(file.length() - 1) == '\n')
                                 {
                                        file = file.erase(file.length() - 1, 1);
                                 }
        
//                                 opilog->write("  File found: " + file + "\n");
                                
//                                 opilog->write("  file: " + file + "\n"); 
//                                 opilog->write("  path: " + path + "\n");
                                 
                                 // if we have a match, assign it
                                 if ( strcasecmp(file.c_str(), path.c_str()) == 0 ) {
//                                         opilog->write("  match found. what a happy day :-)\n");
                                         finalpath = file;
                                 } else {
                                        // we didn't find a file...
//                                        opilog->write("  no match.\n";
                                 }
                         }
                         path = finalpath;
                 } else {
                         opilog->write("Error: cannot open external program for finding the file!\n");
                 }
         } else {
                 opilog->write("Cannot find find-script to execute. Please recheck your configuration!\n");
         }
}       
                         
         
void Path3::convertRelToUnix()	// Relativer pfadteil ab dem match-pfad
{
	int a, l = path.length();
	char c;

	for (a = 0; a < l; ++a) {
		c = path.at(a);
		if (c == '\\' || c == ':')
			path.at(a) = '/';
	}
}

void Path3::convertRelToWinDos()
{
	int a, l = path.length();
	char c;
	
	for (a = 0; a < l; ++a) {
		c = path.at(a);
		if (c == '/' || c == ':')
			path.at(a) = '\\';
	}
}

void Path3::convertRelToMacOS()
{
	int a, l = path.length();
	char c;
	
	for (a = 0; a < l; ++a) {
		c = path.at(a);
		if (c == '/' || c == '\\')
			path.at(a) = ':';
	}
}

string Path3::getFileName() const
{
	if (reffile) {
		int a;

		switch (type) {
			case eUnix:		a = path.rfind('/');
							return path.substr(a + 1);
			case eWinDos:	a = path.rfind('\\');
							return path.substr(a + 1);
			case eMacOS:	a = path.rfind(':');
							return path.substr(a + 1);

			default:		return path;
		}
	} else
		return string();
}

string Path3::getPath() const
{
	if (!reffile)
		return path;
	else {
		int a;
		
		switch (type) {
			case eUnix:		a = path.rfind('/');
							return path.substr(0, a + 1);
			case eWinDos:	a = path.rfind('\\');
							return path.substr(0, a + 1);
			case eMacOS:	a = path.rfind(':');
							return path.substr(0, a + 1);

			default:		return path;	// eEmpty
		}
	}
}

/*
string Path3::getRelPath() const
{
	if (!reffile)
		return path;
	else {
		int a;
		
		switch (type) {
			case eUnix:		
                                a = path.rfind('/'); 
                                return path.substr(0, a + 1);
			case eWinDos:	
                                a = path.rfind('\\');
				return path.substr(0, a + 1);
			case eMacOS:	
                                a = path.rfind(':');
				return path.substr(0, a + 1);
			default:
                                return path;	// eEmpty
		}
	}
}
*/


string Path3::getExtension() const
{
	if (reffile) {
		const string &fname = getFileName();

		int a = fname.rfind('.');
		if (a != string::npos)
			return fname.substr(a + 1);
	}

	return string();
}

string Path3::getFileNameWoExt() const
{
	if (reffile) {
		const string &fname = getFileName();

		int a = fname.rfind('.');
		if (a != string::npos)
			return fname.substr(0, a);
		else
			return fname;
	} else
		return string();
}


/*
int main(int argc, char* argv[])
{
	cout << "path3\n";

	Path3 p3("c:\\this\\really\\rocks\\yeah.man", true);
	Path3 m("c:\\this", false);
	Path3 d("/eox/kernel", false);

	cout << "fname=" << p3.getFileName() << "=\n";
	cout << "path=" << p3.getPath() << "=\n";
	cout << "full=" << p3.getFullPath() << "=\n";

	cout << "matc=" << m.getPath() << "=\n";

	cout << "path type: ";
	switch (p3.getType()) {
		case Path3::eEmpty:		cout << "eEmpty\n"; break;
		case Path3::eUnix:		cout << "eUnix\n"; break;
		case Path3::eWinDos:	cout << "eWinDos\n"; break;
		case Path3::eMacOS:		cout << "eMacOS\n"; break;
	}

	cout << "matched: " << p3.convertPath(m, d) << "\n";

	cout << "newfile=" << p3.getFileName() << "=\n";
	cout << "newpath=" << p3.getPath() << "=\n";
	cout << "newfull=" << p3.getFullPath() << "=\n";
	cout << "extensn=" << p3.getExtension() << "=\n";
	return 0;
}

*/
