    /*///'
 ./%'
,/'    .adAHHHAbn.           e b  i   o    s      |     |    |   |  | ||
%/    adAHY"'"YHAbn
//  .dHY"'     '"YHb.
//  dHY'         'YHb                       ___     ___
//  HH1           1HH                      /  /    /__/     /
//  HH1           1HH  .d888b.            /__/pen /repress /nterface
//  9Hb.         .dHP  887"88b
//  'VHAn.     .aAHA'   "  ;88
//    9HHAbo.adAHAP       4388b        d8888b .d88b 88b 8   8 .d88b 88b
//     '"YTHHHTY"'          781        8b.    8' .7 8 8 8   8 8' .7 8 8
//                     .   ;d81        '888b. 8 .7  8   9. .7 8 .7  8
//                    u8&oo78P'           'V8 8.7   8   '9.7' 8.7   8
//                     '98887'        o888888 '5880 8    'V'  '5880 8
//
//  O3  --  ebios opi-server  ---------------------------- ---- --- -- -
//  Copyright (c) ebios Informationssysteme
//  Written by Marcus Warga
/
                            //////////////////////////////////////////*/

#ifdef _MSC_VER
#include "c:\opi3\libtiff\libtiff\tiffio.h"
#else
#include <tiffio.h>
#endif

#ifndef __o3tiff__
#define __o3tiff__

#include "o3bin.h"
#include "o3image.h"
#include "o3included.h"

class TIFFImage : public Image {
public:
					TIFFImage(const string& filename, IncludedImage& clonesrc);
					~TIFFImage();
	BinLOb*			read();
	void			writeImage(OPIVersion version);
	bool			eoimage() const;

private:
	unsigned long	readrow;
	unsigned long	imageheight;
	unsigned long	imagewidth;
	unsigned long	*raster;
	unsigned long	tiffdatasize;
	unsigned long	scanlinesize;
	TIFF			*tiff;
	BinLOb			*scanline;
	unsigned short	planarconfig;
	unsigned short	samplesperpixel;
	static char		hexdigit[16];
	bool			error;

	void			writeImageData();
	void			writeImageOperands();
};

#endif // __o3tiff__
